/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         jsquery_yyparse
#define yylex           jsquery_yylex
#define yyerror         jsquery_yyerror
#define yydebug         jsquery_yydebug
#define yynerrs         jsquery_yynerrs


/* Copy the first part of user declarations.  */
#line 15 "jsquery_gram.y" /* yacc.c:339  */

#include "postgres.h"

#include "fmgr.h"
#include "utils/builtins.h"

#include "jsquery.h"

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Avoid exit() on fatal scanner errors (a bit ugly -- see yy_fatal_error) */
#undef fprintf
#define fprintf(file, fmt, msg)  fprintf_to_ereport(fmt, msg)

static void
fprintf_to_ereport(const char *fmt, const char *msg)
{
	ereport(ERROR, (errmsg_internal("%s", msg)));
}

/* struct string is shared between scan and gram */
typedef struct string {
	char 	*val;
	int  	len;
	int		total;
} string;
#include <jsquery_gram.h>

/* flex 2.5.4 doesn't bother with a decl for this */
int jsquery_yylex(YYSTYPE * yylval_param);
void jsquery_yyerror(JsQueryParseItem **result, const char *message);

static JsQueryParseItem*
makeItemType(int type)
{
	JsQueryParseItem* v = palloc(sizeof(*v));

	v->type = type;
	v->hint = jsqIndexDefault;
	v->next = NULL;

	return v;
}

static JsQueryParseItem*
makeIndexArray(string *s)
{
	JsQueryParseItem* v = makeItemType(jqiIndexArray);

	v->arrayIndex = pg_atoi(s->val, 4, 0);

	return v;
}

static JsQueryParseItem*
makeItemString(string *s)
{
	JsQueryParseItem *v;

	if (s == NULL)
	{
		v = makeItemType(jqiNull);
	}
	else
	{
		v = makeItemType(jqiString);
		v->string.val = s->val;
		v->string.len = s->len;
	}

	return v;
}

static JsQueryParseItem*
makeItemKey(string *s)
{
	JsQueryParseItem *v;

	v = makeItemString(s);
	v->type = jqiKey;

	return v;
}

static JsQueryParseItem*
makeItemNumeric(string *s)
{
	JsQueryParseItem		*v;

	v = makeItemType(jqiNumeric);
	v->numeric = DatumGetNumeric(DirectFunctionCall3(numeric_in, CStringGetDatum(s->val), 0, -1));

	return v;
}

static JsQueryParseItem*
makeItemBool(bool val) {
	JsQueryParseItem *v = makeItemType(jqiBool);

	v->boolean = val;

	return v;
}

static JsQueryParseItem*
makeItemArray(List *list)
{
	JsQueryParseItem	*v = makeItemType(jqiArray);

	v->array.nelems = list_length(list);

	if (v->array.nelems > 0)
	{
		ListCell	*cell;
		int			i = 0;

		v->array.elems = palloc(sizeof(JsQueryParseItem) * v->array.nelems);

		foreach(cell, list)
			v->array.elems[i++] = (JsQueryParseItem*)lfirst(cell);
	}
	else
	{
		v->array.elems = NULL;
	}

	return v;
}

static JsQueryParseItem*
makeItemBinary(int type, JsQueryParseItem* la, JsQueryParseItem *ra)
{
	JsQueryParseItem  *v = makeItemType(type);

	v->args.left = la;
	v->args.right = ra;

	return v;
}

static JsQueryParseItem*
makeItemUnary(int type, JsQueryParseItem* a)
{
	JsQueryParseItem  *v = makeItemType(type);

	v->arg = a;

	return v;
}

static JsQueryParseItem*
makeItemIs(int isType)
{
	JsQueryParseItem  *v = makeItemType(jqiIs);

	v->isType = isType;

	return v;
}

static JsQueryParseItem*
makeItemList(List *list) {
	JsQueryParseItem	*head, *end;
	ListCell	*cell;

	head = end = (JsQueryParseItem*)linitial(list);

	foreach(cell, list)
	{
		JsQueryParseItem	*c = (JsQueryParseItem*)lfirst(cell);

		if (c == head)
			continue;

		end->next = c;
		end = c;
	}

	return head;
}


#line 264 "jsquery_gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "jsquery_gram.h".  */
#ifndef YY_JSQUERY_YY_JSQUERY_GRAM_H_INCLUDED
# define YY_JSQUERY_YY_JSQUERY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int jsquery_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IN_P = 258,
    IS_P = 259,
    OR_P = 260,
    AND_P = 261,
    NOT_P = 262,
    NULL_P = 263,
    TRUE_P = 264,
    ARRAY_T = 265,
    FALSE_P = 266,
    NUMERIC_T = 267,
    OBJECT_T = 268,
    STRING_T = 269,
    BOOLEAN_T = 270,
    STRING_P = 271,
    NUMERIC_P = 272,
    INT_P = 273,
    HINT_P = 274
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 214 "jsquery_gram.y" /* yacc.c:355  */

	string 				str;
	List				*elems; /* list of JsQueryParseItem */

	JsQueryParseItem	*value;
	JsQueryHint			hint;

#line 332 "jsquery_gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int jsquery_yyparse (JsQueryParseItem **result);

#endif /* !YY_JSQUERY_YY_JSQUERY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 348 "jsquery_gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  44
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   194

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  11
/* YYNRULES -- Number of rules.  */
#define YYNRULES  78
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  112

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   274

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    31,    34,    32,    30,     2,
      20,    21,    26,     2,    24,     2,    35,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    33,     2,
      27,    25,    28,     2,    29,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    22,     2,    23,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   246,   246,   247,   251,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   274,   275,   279,   280,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   303,   304,   305,   310,   311,   312,   313,   314,   315,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   352,   353,   357,   358,   359
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IN_P", "IS_P", "OR_P", "AND_P", "NOT_P",
  "NULL_P", "TRUE_P", "ARRAY_T", "FALSE_P", "NUMERIC_T", "OBJECT_T",
  "STRING_T", "BOOLEAN_T", "STRING_P", "NUMERIC_P", "INT_P", "HINT_P",
  "'('", "')'", "'['", "']'", "','", "'='", "'*'", "'<'", "'>'", "'@'",
  "'&'", "'#'", "'%'", "':'", "'$'", "'.'", "$accept", "result", "array",
  "scalar_value", "value_list", "numeric", "right_expr", "expr", "key",
  "key_any", "path", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      40,    41,    91,    93,    44,    61,    42,    60,    62,    64,
      38,    35,    37,    58,    36,    46
};
# endif

#define YYPACT_NINF -80

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-80)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      88,   -80,   -80,   -80,   -80,    55,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,    88,   -12,    -7,
     -11,    21,   -80,    26,    44,   -80,     0,    13,   129,     9,
     152,    28,    93,   -13,    14,   120,   -80,   -80,    11,   -80,
     -80,   -80,   -80,   -80,   -80,    88,    88,    13,   129,     9,
      88,    50,   120,   -80,   176,   -80,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   176,   -80,   -80,
     -80,   -80,   -80,    59,    66,   -80,    59,   -80,    66,    66,
     -80,   -80,   -80,   -80,   101,   -80,   -80,    35,   -80,   -80,
      27,    89,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   176,
     -80,   -80
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,    60,    61,    62,    63,     0,    64,    65,    66,    67,
      68,    69,    70,    71,    59,    72,    73,     0,    50,     0,
      51,    52,    56,     0,     2,    76,     0,    60,    61,     0,
       0,     0,     0,     0,     0,     0,    45,    43,     0,    53,
      57,    58,    54,    55,     1,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,    36,    37,    38,    39,    40,
      44,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,     5,    19,    20,     0,    28,    27,
      25,    23,    24,     0,     0,    29,     0,    30,     0,     0,
      75,    74,    78,    47,    49,    48,    42,     0,    77,    21,
       0,     0,    31,    34,    32,    33,    35,    46,    26,     0,
       4,    22
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -80,   -80,   -79,   -30,    32,   -31,   -18,    -3,   -29,    63,
     -80
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    23,    79,    99,   100,    85,    36,    24,    25,    92,
      26
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      80,    87,    37,    47,    48,   103,    91,    41,    53,   105,
     106,    60,    47,    48,    38,    88,    45,    46,    40,    49,
      50,    39,    42,    91,    40,    30,    44,    31,    32,    51,
      34,    96,    93,    54,    30,    52,    31,    32,    51,    34,
      45,    46,    94,    95,    89,    81,    82,    97,   108,    45,
      46,   109,   102,    83,    43,   104,   107,    84,    27,    28,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    29,    17,    81,    82,    88,   111,
      30,    18,    31,    32,    33,    34,    20,    21,    77,    22,
      35,     1,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    46,    17,   101,
      81,    82,   110,   109,    18,    98,     0,    19,    86,    20,
      21,     0,    22,     1,     2,     3,     4,    90,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    55,
       0,    56,    57,    58,    59,     0,    18,     0,     0,    19,
       0,    20,    21,     0,    22,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,     0,     0,     0,    77,     0,     0,     0,    78,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76
};

static const yytype_int8 yycheck[] =
{
      30,    32,     5,     3,     4,    84,    35,    18,    26,    88,
      89,    29,     3,     4,    17,    28,     5,     6,    31,    19,
      20,    33,    33,    52,    31,    25,     0,    27,    28,    29,
      30,    49,    21,    20,    25,    35,    27,    28,    29,    30,
       5,     6,    45,    46,    30,    17,    18,    50,    21,     5,
       6,    24,    83,    25,    33,    86,    21,    29,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    17,    18,    28,   109,
      25,    26,    27,    28,    29,    30,    31,    32,    22,    34,
      35,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,     6,    20,    77,
      17,    18,    23,    24,    26,    52,    -1,    29,    25,    31,
      32,    -1,    34,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    10,
      -1,    12,    13,    14,    15,    -1,    26,    -1,    -1,    29,
      -1,    31,    32,    -1,    34,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    20,    26,    29,
      31,    32,    34,    37,    43,    44,    46,     3,     4,    19,
      25,    27,    28,    29,    30,    35,    42,    43,    43,    33,
      31,    18,    33,    33,     0,     5,     6,     3,     4,    19,
      20,    29,    35,    42,    20,    10,    12,    13,    14,    15,
      42,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    22,    26,    38,
      39,    17,    18,    25,    29,    41,    25,    41,    28,    30,
       7,    44,    45,    21,    43,    43,    42,    43,    45,    39,
      40,    40,    41,    38,    41,    38,    38,    21,    21,    24,
      23,    39
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    36,    37,    37,    38,    39,    39,    39,    39,    39,
      39,    39,    39,    39,    39,    39,    39,    39,    39,    39,
      39,    40,    40,    41,    41,    42,    42,    42,    42,    42,
      42,    42,    42,    42,    42,    42,    42,    42,    42,    42,
      42,    43,    43,    43,    43,    43,    43,    43,    43,    43,
      44,    44,    44,    44,    44,    44,    44,    44,    44,    44,
      44,    44,    44,    44,    44,    44,    44,    44,    44,    44,
      44,    44,    44,    44,    45,    45,    46,    46,    46
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     2,     4,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       2,     2,     3,     2,     3,     2,     4,     3,     3,     3,
       1,     1,     1,     2,     2,     2,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (result, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, result); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, JsQueryParseItem **result)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (result);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, JsQueryParseItem **result)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, result);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, JsQueryParseItem **result)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , result);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, result); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, JsQueryParseItem **result)
{
  YYUSE (yyvaluep);
  YYUSE (result);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (JsQueryParseItem **result)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 246 "jsquery_gram.y" /* yacc.c:1646  */
    { *result = (yyvsp[0].value); }
#line 1523 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 247 "jsquery_gram.y" /* yacc.c:1646  */
    { *result = NULL; }
#line 1529 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 251 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemArray((yyvsp[-1].elems)); }
#line 1535 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 5:
#line 255 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1541 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 6:
#line 256 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1547 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 7:
#line 257 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1553 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 8:
#line 258 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1559 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 9:
#line 259 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1565 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 10:
#line 260 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1571 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 11:
#line 261 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(NULL); }
#line 1577 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 12:
#line 262 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemBool(true); }
#line 1583 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 13:
#line 263 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1589 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 14:
#line 264 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemBool(false); }
#line 1595 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 15:
#line 265 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1601 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 16:
#line 266 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1607 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 17:
#line 267 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1613 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 18:
#line 268 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemString(&(yyvsp[0].str)); }
#line 1619 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 19:
#line 269 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemNumeric(&(yyvsp[0].str)); }
#line 1625 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 20:
#line 270 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemNumeric(&(yyvsp[0].str)); }
#line 1631 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 21:
#line 274 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.elems) = lappend(NIL, (yyvsp[0].value)); }
#line 1637 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 22:
#line 275 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.elems) = lappend((yyvsp[-2].elems), (yyvsp[0].value)); }
#line 1643 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 23:
#line 279 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemNumeric(&(yyvsp[0].str)); }
#line 1649 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 24:
#line 280 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemNumeric(&(yyvsp[0].str)); }
#line 1655 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 25:
#line 284 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiEqual, (yyvsp[0].value)); }
#line 1661 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 26:
#line 285 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiIn, makeItemArray((yyvsp[-1].elems))); }
#line 1667 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 27:
#line 286 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiEqual, (yyvsp[0].value)); }
#line 1673 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 28:
#line 287 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiEqual, makeItemType(jqiAny)); }
#line 1679 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 29:
#line 288 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiLess, (yyvsp[0].value)); }
#line 1685 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 30:
#line 289 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiGreater, (yyvsp[0].value)); }
#line 1691 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 31:
#line 290 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiLessOrEqual, (yyvsp[0].value)); }
#line 1697 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 32:
#line 291 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiGreaterOrEqual, (yyvsp[0].value)); }
#line 1703 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 33:
#line 292 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiContains, (yyvsp[0].value)); }
#line 1709 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 34:
#line 293 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiContained, (yyvsp[0].value)); }
#line 1715 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 35:
#line 294 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiOverlap, (yyvsp[0].value)); }
#line 1721 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 36:
#line 295 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemIs(jbvArray); }
#line 1727 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 37:
#line 296 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemIs(jbvNumeric); }
#line 1733 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 38:
#line 297 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemIs(jbvObject); }
#line 1739 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 39:
#line 298 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemIs(jbvString); }
#line 1745 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 40:
#line 299 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemIs(jbvBool); }
#line 1751 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 41:
#line 303 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemList(lappend((yyvsp[-1].elems), (yyvsp[0].value))); }
#line 1757 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 42:
#line 304 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyvsp[0].value)->hint = (yyvsp[-1].hint); (yyval.value) = makeItemList(lappend((yyvsp[-2].elems), (yyvsp[0].value))); }
#line 1763 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 43:
#line 305 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemUnary(jqiNot, (yyvsp[0].value)); }
#line 1769 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 44:
#line 310 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyvsp[0].value)->hint = (yyvsp[-1].hint); (yyval.value) = makeItemList(lappend(lappend(NIL, makeItemKey(&(yyvsp[-2].str))), (yyvsp[0].value))); }
#line 1775 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 45:
#line 311 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemList(lappend(lappend(NIL, makeItemKey(&(yyvsp[-1].str))), (yyvsp[0].value))); }
#line 1781 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 46:
#line 312 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemList(lappend((yyvsp[-3].elems), (yyvsp[-1].value))); }
#line 1787 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 47:
#line 313 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = (yyvsp[-1].value); }
#line 1793 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 48:
#line 314 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemBinary(jqiAnd, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 1799 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 49:
#line 315 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemBinary(jqiOr, (yyvsp[-2].value), (yyvsp[0].value)); }
#line 1805 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 50:
#line 322 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemType(jqiAny); }
#line 1811 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 51:
#line 323 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemType(jqiAnyArray); }
#line 1817 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 52:
#line 324 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemType(jqiAnyKey); }
#line 1823 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 53:
#line 325 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemType(jqiAll); }
#line 1829 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 54:
#line 326 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemType(jqiAllArray); }
#line 1835 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 55:
#line 327 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemType(jqiAllKey); }
#line 1841 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 56:
#line 328 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemType(jqiCurrent); }
#line 1847 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 57:
#line 329 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemType(jqiLength); }
#line 1853 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 58:
#line 330 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeIndexArray(&(yyvsp[0].str)); }
#line 1859 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 59:
#line 331 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1865 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 60:
#line 332 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1871 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 61:
#line 333 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1877 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 62:
#line 334 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1883 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 63:
#line 335 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1889 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 64:
#line 336 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1895 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 65:
#line 337 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1901 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 66:
#line 338 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1907 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 67:
#line 339 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1913 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 68:
#line 340 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1919 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 69:
#line 341 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1925 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 70:
#line 342 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1931 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 71:
#line 343 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1937 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 72:
#line 344 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1943 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 73:
#line 345 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1949 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 74:
#line 352 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = (yyval.value); }
#line 1955 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 75:
#line 353 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeItemKey(&(yyvsp[0].str)); }
#line 1961 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 76:
#line 357 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.elems) = lappend(NIL, (yyvsp[0].value)); }
#line 1967 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 77:
#line 358 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.elems) = lappend((yyvsp[-2].elems), (yyvsp[0].value)); }
#line 1973 "jsquery_gram.c" /* yacc.c:1646  */
    break;

  case 78:
#line 359 "jsquery_gram.y" /* yacc.c:1646  */
    { (yyval.elems) = lappend(lappend(NIL, makeItemKey(&(yyvsp[-2].str))), (yyvsp[0].value)); }
#line 1979 "jsquery_gram.c" /* yacc.c:1646  */
    break;


#line 1983 "jsquery_gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (result, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (result, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, result);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, result);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (result, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, result);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, result);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 362 "jsquery_gram.y" /* yacc.c:1906  */


#include "jsquery_scan.c"
